<template>
    <div class="edit-view">
        <el-form :model="formData" :rules="rules" ref="form" label-width="172px" label-position="right" size="small"
                 style="max-width: 500px;">
                <el-form-item prop="type" label="类型">
                            <el-select v-model="formData.type" clearable filterable  placeholder="请选择">
                                <el-option
                                        v-for="item in typeOptions"
                                        :key="item.value"
                                        :label="item.label"
                                        :value="item.value">
                                </el-option>
                            </el-select>
                </el-form-item>
                <el-form-item prop="level" label="级别">
                            <el-input-number type="number" v-model="formData.level"></el-input-number>
                </el-form-item>
                <el-form-item prop="likes" label="所需点赞">
                            <el-input-number type="number" v-model="formData.likes"></el-input-number>
                </el-form-item>
                <el-form-item prop="monthSales" label="所需月销">
                            <el-input-number type="number" v-model="formData.monthSales"></el-input-number>
                </el-form-item>
                <el-form-item prop="zeroSalesDay" label="一个月销量可为0的天数">
                            <el-input-number type="number" v-model="formData.zeroSalesDay"></el-input-number>
                </el-form-item>
                <el-form-item prop="lessMonthSales" label="月最低销量">
                            <el-input-number type="number" v-model="formData.lessMonthSales"></el-input-number>
                </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving"
                           type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving"
                           type="danger" v-if="formData.id">删除
                </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
    export default {
        name: 'PriorityEdit',
        created() {
            if (this.$route.query.id) {
                this.$http
                    .get('priority/get/'+this.$route.query.id)
                    .then(res => {
                        this.formData = res;
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error);
                    });
            }
        },
        data() {
            return {
                saving: false,
                formData: {
                },
                rules: {
                },
                            typeOptions:[{"label":"商户","value":0},{"label":"商品","value":1}],
            }
        },
        methods: {
            onSave() {
                this.$refs.form.validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        return false;
                    }
                });
            },
            submit() {
                let data = {...this.formData};

                this.saving = true;
                this.$http
                    .post('/priority/save', data, {body: 'json'})
                    .then(res => {
                        this.saving = false;
                        this.$message.success('成功');
                        this.$router.go(-1);
                    })
                    .catch(e => {
                        console.log(e);
                        this.saving = false;
                        this.$message.error(e.error);
                    });
            },
            onDelete() {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/priority/del/${this.formData.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                }).catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                })
            },
        }
    }
</script>
<style lang="less" scoped>
</style>
